//File: ScriptProcess.cpp
//Author: Colin Kern (colin.kern AT gmail DOT edu)

#include "ScriptProcess.h"

ScriptProcess::ScriptProcess(const QString &path, int nAttempts, QObject *parent)
	: QProcess(parent)
{
	filePath = path;
	attemptCount = nAttempts;
	connect(this, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(finish(int, QProcess::ExitStatus)));
}

ScriptProcess::~ScriptProcess()
{
}

const QString &ScriptProcess::getFilePath() const
{
	return filePath;
}

int ScriptProcess::attempts() const
{
	return attemptCount;
}

void ScriptProcess::finish(int, QProcess::ExitStatus status)
{
	emit done(this, status);
}
