//File: ScriptProcess.h
//Author: Colin Kern (colin.kern AT gmail DOT edu)

#ifndef SCRIPTPROCESS_H_
#define SCRIPTPROCESS_H_

#include <QProcess>
#include <QString>

class ScriptProcess : public QProcess
{
	Q_OBJECT

	public:
		ScriptProcess(const QString &path, int nAttempts, QObject *parent = 0);
		virtual ~ScriptProcess();
		
		const QString &getFilePath() const;
		int attempts() const;

	signals:
		void done(ScriptProcess *process, QProcess::ExitStatus status);

	private slots:
		void finish(int exitCode, QProcess::ExitStatus status);
		
	private:
		QString filePath;
		int attemptCount;
};

#endif /*SCRIPTPROCESS_H_*/
