//File: TagFix.h
//Author: Colin Kern (colin.kern AT gmail DOT edu)

#ifndef TAGFIX_H
#define TAGFIX_H

#include <QMainWindow>
#include "ui_TagFix.h"
#include <QList>
#include <QPair>
#include <QString>
#include <QProcess>
#include <QDir>
#include <QStringList>

class QTreeView;
class QStandardItemModel;
class QStandardItem;
class QLabel;
class QProgressBar;
class ScriptProcess;
class QPushButton;

class TagFix : public QMainWindow {
Q_OBJECT

public:
	TagFix(QWidget *parent = 0);
	~TagFix();

private slots:
	void aboutQt();
	void chooseFile();
	void chooseDirectory();
	void scanComplete(ScriptProcess *process, QProcess::ExitStatus status);
	void error(QProcess::ProcessError);
	void setScriptPath();
	void stopJobs();
	void saveTags();

private:
	QList<QStandardItem*> extractDataItem(const QString &track) const;
	void scanFile(QPair<QString, int> *filename);
	void createStatusBar();
	void sendNextQuery();
	void updateTitleAndStatus();
	void addDirectoryToQueue(QDir &dir);
	
	Ui::TagFixClass ui;
	QTreeView *treeView;
	QStandardItemModel *model;
	int queryCount;
	QLabel *statusLabel;
	QProgressBar *progress;
	QList<QPair<QString, int>*> queue;
	QString scriptPath;
	QPushButton *stopButton;
	QPushButton *saveButton;
	QStringList failedFiles;
};

#endif // TAGFIX_H
